/*
Copyright (c) Members of the EGEE Collaboration. 2004-2010.
See http://www.eu-egee.org/partners for details on the copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*

  !! Automatically generated file
  !! Do not edit, your changes will be discarded upon build
  !! Change the corresponding template file ./src/Event.cpp.T

*/

#include <utility>
#include <vector>
#include <string>
#include <stdio.h>

#include <errno.h>

#include "glite/jobid/cjobid.h"

#include "Event.h"
#include "glite/lb/events.h"
#include "glite/lb/notifid.h"
#include "glite/lb/LoggingExceptions.h"

#include "consumer.h"

EWL_BEGIN_NAMESPACE;

#define CLASS_PREFIX "glite::lb::Event::"


Event::Event(void)
{
  type = UNDEF;
  flesh = 0;
}


Event::Event(const Event &in)
{
  type = in.type;
  flesh = in.flesh;
  if (flesh) flesh->use();
}


Event::Event(edg_wll_Event *in)
{
  type = (Type)in->type;
  flesh = new CountRef<Event>((void*)in);
}


Event::~Event(void)
{
  if (flesh) flesh->release();
}


Event & 
Event::operator= (const Event &in)
{
  if (flesh) flesh->release();
  type = in.type;
  flesh = in.flesh;
  if (flesh) flesh->use();
  
  return *this;
}

int Event::getValInt(Attr attr)	const
{
	edg_wll_Event const	*cev = (edg_wll_Event *) flesh->ptr;

	switch (attr) {
		case Event::SOURCE: return(cev->any.source);
		case Event::LEVEL: return(cev->any.level);
		case Event::PRIORITY: return(cev->any.priority);
		default: break;
	}

	switch (cev->type) {
		case PBSPENDING:
		switch (attr) {
			default: goto badattr;
		}
		case CLEAR:
		switch (attr) {
			case Event::REASON: return(cev->clear.reason);
			default: goto badattr;
		}
		case GRANTPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case CONNECTJOB:
		switch (attr) {
			case Event::JOBTYPE: return(cev->connectJob.jobtype);
			default: goto badattr;
		}
		case VMCREATE:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case TRANSFER:
		switch (attr) {
			case Event::RESULT: return(cev->transfer.result);
			case Event::DESTINATION: return(cev->transfer.destination);
			default: goto badattr;
		}
		case PBSACCEPTED:
		switch (attr) {
			case Event::FROM: return(cev->PBSAccepted.from);
			default: goto badattr;
		}
		case PBSDONE:
		switch (attr) {
			case Event::EXIT_STATUS: return(cev->PBSDone.exit_status);
			default: goto badattr;
		}
		case PBSWAITING:
		switch (attr) {
			default: goto badattr;
		}
		case RUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case CURDESCR:
		switch (attr) {
			default: goto badattr;
		}
		case SANDBOX:
		switch (attr) {
			case Event::SANDBOX_TYPE: return(cev->sandbox.sandbox_type);
			default: goto badattr;
		}
		case HELPERRETURN:
		switch (attr) {
			case Event::SRC_ROLE: return(cev->helperReturn.src_role);
			default: goto badattr;
		}
		case PURGE:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSHADOWEXITED:
		switch (attr) {
			case Event::SHADOW_EXIT_STATUS: return(cev->CondorShadowExited.shadow_exit_status);
			case Event::SHADOW_PID: return(cev->CondorShadowExited.shadow_pid);
			default: goto badattr;
		}
		case CREAMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case PBSRUN:
		switch (attr) {
			case Event::PID: return(cev->PBSRun.pid);
			default: goto badattr;
		}
		case CONDORREJECT:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->CondorReject.status_code);
			default: goto badattr;
		}
		case SUSPEND:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMRESUME:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->CREAMResume.status_code);
			default: goto badattr;
		}
		case PBSRERUN:
		switch (attr) {
			default: goto badattr;
		}
		case PBSRESOURCEUSAGE:
		switch (attr) {
			case Event::USAGE: return(cev->PBSResourceUsage.usage);
			default: goto badattr;
		}
		case CHANGEACL:
		switch (attr) {
			case Event::USER_ID_TYPE: return(cev->changeACL.user_id_type);
			case Event::PERMISSION: return(cev->changeACL.permission);
			case Event::OPERATION: return(cev->changeACL.operation);
			case Event::PERMISSION_TYPE: return(cev->changeACL.permission_type);
			default: goto badattr;
		}
		case CREAMSTART:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSUSPEND:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->CREAMSuspend.status_code);
			default: goto badattr;
		}
		case CREAMDONE:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->CREAMDone.status_code);
			default: goto badattr;
		}
		case CONDORSTARTERSTARTED:
		switch (attr) {
			case Event::STARTER_PID: return(cev->CondorStarterStarted.starter_pid);
			default: goto badattr;
		}
		case DONE:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->done.status_code);
			case Event::EXIT_CODE: return(cev->done.exit_code);
			default: goto badattr;
		}
		case TAKEPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORMATCH:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSHADOWSTARTED:
		switch (attr) {
			case Event::SHADOW_PORT: return(cev->CondorShadowStarted.shadow_port);
			case Event::SHADOW_PID: return(cev->CondorShadowStarted.shadow_pid);
			default: goto badattr;
		}
		case FILETRANSFER:
		switch (attr) {
			case Event::RESULT: return(cev->fileTransfer.result);
			default: goto badattr;
		}
		case VMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case MATCH:
		switch (attr) {
			default: goto badattr;
		}
		case REFUSED:
		switch (attr) {
			case Event::FROM: return(cev->refused.from);
			default: goto badattr;
		}
		case CREAMREALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSTARTEREXITED:
		switch (attr) {
			case Event::STARTER_EXIT_STATUS: return(cev->CondorStarterExited.starter_exit_status);
			case Event::JOB_PID: return(cev->CondorStarterExited.job_pid);
			case Event::JOB_EXIT_STATUS: return(cev->CondorStarterExited.job_exit_status);
			case Event::STARTER_PID: return(cev->CondorStarterExited.starter_pid);
			default: goto badattr;
		}
		case CREAMSTATUS:
		switch (attr) {
			case Event::RESULT: return(cev->CREAMStatus.result);
			default: goto badattr;
		}
		case CONDORERROR:
		switch (attr) {
			default: goto badattr;
		}
		case LISTENER:
		switch (attr) {
			case Event::SVC_PORT: return(cev->listener.svc_port);
			default: goto badattr;
		}
		case NOTIFICATION:
		switch (attr) {
			case Event::EXPIRES: return(cev->notification.expires);
			case Event::DEST_PORT: return(cev->notification.dest_port);
			default: goto badattr;
		}
		case VMSHUTDOWN:
		switch (attr) {
			default: goto badattr;
		}
		case PBSABORT:
		switch (attr) {
			default: goto badattr;
		}
		case ACCEPTED:
		switch (attr) {
			case Event::FROM: return(cev->accepted.from);
			default: goto badattr;
		}
		case VMSTOP:
		switch (attr) {
			default: goto badattr;
		}
		case RESOURCEUSAGE:
		switch (attr) {
			default: goto badattr;
		}
		case CANCEL:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->cancel.status_code);
			default: goto badattr;
		}
		case PBSTRANSFER:
		switch (attr) {
			case Event::DESTINATION: return(cev->PBSTransfer.destination);
			case Event::RESULT: return(cev->PBSTransfer.result);
			default: goto badattr;
		}
		case CREAMCALL:
		switch (attr) {
			case Event::RESULT: return(cev->CREAMCall.result);
			case Event::COMMAND: return(cev->CREAMCall.command);
			case Event::CALLEE: return(cev->CREAMCall.callee);
			default: goto badattr;
		}
		case VMRESUME:
		switch (attr) {
			default: goto badattr;
		}
		case HELPERCALL:
		switch (attr) {
			case Event::SRC_ROLE: return(cev->helperCall.src_role);
			default: goto badattr;
		}
		case PBSERROR:
		switch (attr) {
			default: goto badattr;
		}
		case COLLECTIONSTATE:
		switch (attr) {
			case Event::DONE_CODE: return(cev->collectionState.done_code);
			default: goto badattr;
		}
		case ABORT:
		switch (attr) {
			default: goto badattr;
		}
		case ENQUEUED:
		switch (attr) {
			case Event::RESULT: return(cev->enQueued.result);
			default: goto badattr;
		}
		case USERTAG:
		switch (attr) {
			default: goto badattr;
		}
		case REALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case VMHOST:
		switch (attr) {
			default: goto badattr;
		}
		case VMIMAGE:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSTORE:
		switch (attr) {
			case Event::COMMAND: return(cev->CREAMStore.command);
			case Event::RESULT: return(cev->CREAMStore.result);
			default: goto badattr;
		}
		case CHKPT:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMPURGE:
		switch (attr) {
			default: goto badattr;
		}
		case PBSMATCH:
		switch (attr) {
			default: goto badattr;
		}
		case DEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMABORT:
		switch (attr) {
			default: goto badattr;
		}
		case PBSDEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case FILETRANSFERREGISTER:
		switch (attr) {
			default: goto badattr;
		}
		case RESUBMISSION:
		switch (attr) {
			case Event::RESULT: return(cev->resubmission.result);
			default: goto badattr;
		}
		case CREAMCANCEL:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->CREAMCancel.status_code);
			default: goto badattr;
		}
		case PBSREFUSED:
		switch (attr) {
			case Event::FROM: return(cev->PBSRefused.from);
			default: goto badattr;
		}
		case VMDONE:
		switch (attr) {
			case Event::STATUS_CODE: return(cev->vMDone.status_code);
			default: goto badattr;
		}
		case CONDORRESOURCEUSAGE:
		switch (attr) {
			case Event::USAGE: return(cev->CondorResourceUsage.usage);
			default: goto badattr;
		}
		case PENDING:
		switch (attr) {
			default: goto badattr;
		}
		case REGJOB:
		switch (attr) {
			case Event::JOBTYPE: return(cev->regJob.jobtype);
			case Event::NSUBJOBS: return(cev->regJob.nsubjobs);
			default: goto badattr;
		}
		case PBSINTERNALSTATECHANGE:
		switch (attr) {
			case Event::NEWSTATE: return(cev->PBSInternalStateChange.newstate);
			case Event::OLDSUBSTATE: return(cev->PBSInternalStateChange.oldsubstate);
			case Event::OLDSTATE: return(cev->PBSInternalStateChange.oldstate);
			case Event::NEWSUBSTATE: return(cev->PBSInternalStateChange.newsubstate);
			default: goto badattr;
		}
		case DISCONNECTJOB:
		switch (attr) {
			default: goto badattr;
		}
		case RESUME:
		switch (attr) {
			default: goto badattr;
		}
		case PBSQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		default:
		  STACK_ADD;
		  throw(Exception(EXCEPTION_MANDATORY, EINVAL,
				  "attribute is not of int type"));
        }
badattr:
        STACK_ADD;
        throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
	return -1; /* gcc, shut up! */
}

float Event::getValFloat(Attr attr)	const
{
	edg_wll_Event const	*cev = (edg_wll_Event *) flesh->ptr;

	switch (attr) {
		default: break;
	}

	switch (cev->type) {
		case PBSPENDING:
		switch (attr) {
			default: goto badattr;
		}
		case CLEAR:
		switch (attr) {
			default: goto badattr;
		}
		case GRANTPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case CONNECTJOB:
		switch (attr) {
			default: goto badattr;
		}
		case VMCREATE:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case TRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case PBSACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case PBSDONE:
		switch (attr) {
			default: goto badattr;
		}
		case PBSWAITING:
		switch (attr) {
			default: goto badattr;
		}
		case RUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case CURDESCR:
		switch (attr) {
			default: goto badattr;
		}
		case SANDBOX:
		switch (attr) {
			default: goto badattr;
		}
		case HELPERRETURN:
		switch (attr) {
			default: goto badattr;
		}
		case PURGE:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSHADOWEXITED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case PBSRUN:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORREJECT:
		switch (attr) {
			default: goto badattr;
		}
		case SUSPEND:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMRESUME:
		switch (attr) {
			default: goto badattr;
		}
		case PBSRERUN:
		switch (attr) {
			default: goto badattr;
		}
		case PBSRESOURCEUSAGE:
		switch (attr) {
			default: goto badattr;
		}
		case CHANGEACL:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSTART:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSUSPEND:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMDONE:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSTARTERSTARTED:
		switch (attr) {
			default: goto badattr;
		}
		case DONE:
		switch (attr) {
			default: goto badattr;
		}
		case TAKEPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORMATCH:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSHADOWSTARTED:
		switch (attr) {
			default: goto badattr;
		}
		case FILETRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case VMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case MATCH:
		switch (attr) {
			default: goto badattr;
		}
		case REFUSED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMREALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSTARTEREXITED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSTATUS:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORERROR:
		switch (attr) {
			default: goto badattr;
		}
		case LISTENER:
		switch (attr) {
			default: goto badattr;
		}
		case NOTIFICATION:
		switch (attr) {
			default: goto badattr;
		}
		case VMSHUTDOWN:
		switch (attr) {
			default: goto badattr;
		}
		case PBSABORT:
		switch (attr) {
			default: goto badattr;
		}
		case ACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case VMSTOP:
		switch (attr) {
			default: goto badattr;
		}
		case RESOURCEUSAGE:
		switch (attr) {
			default: goto badattr;
		}
		case CANCEL:
		switch (attr) {
			default: goto badattr;
		}
		case PBSTRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMCALL:
		switch (attr) {
			default: goto badattr;
		}
		case VMRESUME:
		switch (attr) {
			default: goto badattr;
		}
		case HELPERCALL:
		switch (attr) {
			default: goto badattr;
		}
		case PBSERROR:
		switch (attr) {
			default: goto badattr;
		}
		case COLLECTIONSTATE:
		switch (attr) {
			default: goto badattr;
		}
		case ABORT:
		switch (attr) {
			default: goto badattr;
		}
		case ENQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case USERTAG:
		switch (attr) {
			default: goto badattr;
		}
		case REALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case VMHOST:
		switch (attr) {
			default: goto badattr;
		}
		case VMIMAGE:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSTORE:
		switch (attr) {
			default: goto badattr;
		}
		case CHKPT:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMPURGE:
		switch (attr) {
			default: goto badattr;
		}
		case PBSMATCH:
		switch (attr) {
			default: goto badattr;
		}
		case DEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMABORT:
		switch (attr) {
			default: goto badattr;
		}
		case PBSDEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case FILETRANSFERREGISTER:
		switch (attr) {
			default: goto badattr;
		}
		case RESUBMISSION:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMCANCEL:
		switch (attr) {
			default: goto badattr;
		}
		case PBSREFUSED:
		switch (attr) {
			default: goto badattr;
		}
		case VMDONE:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORRESOURCEUSAGE:
		switch (attr) {
			default: goto badattr;
		}
		case PENDING:
		switch (attr) {
			default: goto badattr;
		}
		case REGJOB:
		switch (attr) {
			default: goto badattr;
		}
		case PBSINTERNALSTATECHANGE:
		switch (attr) {
			default: goto badattr;
		}
		case DISCONNECTJOB:
		switch (attr) {
			default: goto badattr;
		}
		case RESUME:
		switch (attr) {
			default: goto badattr;
		}
		case PBSQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		default:
		  STACK_ADD;
		  throw(Exception(EXCEPTION_MANDATORY, EINVAL,
				  "attribute is not of float type"));
        }
badattr:
        STACK_ADD;
        throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
	return -1; /* gcc, shut up! */
}

double Event::getValDouble(Attr attr)	const
{
	edg_wll_Event const	*cev = (edg_wll_Event *) flesh->ptr;

	switch (attr) {
		default: break;
	}

	switch (cev->type) {
		case PBSPENDING:
		switch (attr) {
			default: goto badattr;
		}
		case CLEAR:
		switch (attr) {
			default: goto badattr;
		}
		case GRANTPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case CONNECTJOB:
		switch (attr) {
			default: goto badattr;
		}
		case VMCREATE:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case TRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case PBSACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case PBSDONE:
		switch (attr) {
			default: goto badattr;
		}
		case PBSWAITING:
		switch (attr) {
			default: goto badattr;
		}
		case RUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case CURDESCR:
		switch (attr) {
			default: goto badattr;
		}
		case SANDBOX:
		switch (attr) {
			default: goto badattr;
		}
		case HELPERRETURN:
		switch (attr) {
			default: goto badattr;
		}
		case PURGE:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSHADOWEXITED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case PBSRUN:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORREJECT:
		switch (attr) {
			default: goto badattr;
		}
		case SUSPEND:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMRESUME:
		switch (attr) {
			default: goto badattr;
		}
		case PBSRERUN:
		switch (attr) {
			default: goto badattr;
		}
		case PBSRESOURCEUSAGE:
		switch (attr) {
			default: goto badattr;
		}
		case CHANGEACL:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSTART:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSUSPEND:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMDONE:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSTARTERSTARTED:
		switch (attr) {
			default: goto badattr;
		}
		case DONE:
		switch (attr) {
			default: goto badattr;
		}
		case TAKEPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORMATCH:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSHADOWSTARTED:
		switch (attr) {
			default: goto badattr;
		}
		case FILETRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case VMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case MATCH:
		switch (attr) {
			default: goto badattr;
		}
		case REFUSED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMREALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORSTARTEREXITED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSTATUS:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORERROR:
		switch (attr) {
			default: goto badattr;
		}
		case LISTENER:
		switch (attr) {
			default: goto badattr;
		}
		case NOTIFICATION:
		switch (attr) {
			default: goto badattr;
		}
		case VMSHUTDOWN:
		switch (attr) {
			default: goto badattr;
		}
		case PBSABORT:
		switch (attr) {
			default: goto badattr;
		}
		case ACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case VMSTOP:
		switch (attr) {
			default: goto badattr;
		}
		case RESOURCEUSAGE:
		switch (attr) {
			case Event::QUANTITY: return(cev->resourceUsage.quantity);
			default: goto badattr;
		}
		case CANCEL:
		switch (attr) {
			default: goto badattr;
		}
		case PBSTRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMCALL:
		switch (attr) {
			default: goto badattr;
		}
		case VMRESUME:
		switch (attr) {
			default: goto badattr;
		}
		case HELPERCALL:
		switch (attr) {
			default: goto badattr;
		}
		case PBSERROR:
		switch (attr) {
			default: goto badattr;
		}
		case COLLECTIONSTATE:
		switch (attr) {
			default: goto badattr;
		}
		case ABORT:
		switch (attr) {
			default: goto badattr;
		}
		case ENQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case USERTAG:
		switch (attr) {
			default: goto badattr;
		}
		case REALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case VMHOST:
		switch (attr) {
			default: goto badattr;
		}
		case VMIMAGE:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMSTORE:
		switch (attr) {
			default: goto badattr;
		}
		case CHKPT:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMPURGE:
		switch (attr) {
			default: goto badattr;
		}
		case PBSMATCH:
		switch (attr) {
			default: goto badattr;
		}
		case DEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMABORT:
		switch (attr) {
			default: goto badattr;
		}
		case PBSDEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case FILETRANSFERREGISTER:
		switch (attr) {
			default: goto badattr;
		}
		case RESUBMISSION:
		switch (attr) {
			default: goto badattr;
		}
		case CREAMCANCEL:
		switch (attr) {
			default: goto badattr;
		}
		case PBSREFUSED:
		switch (attr) {
			default: goto badattr;
		}
		case VMDONE:
		switch (attr) {
			default: goto badattr;
		}
		case CONDORRESOURCEUSAGE:
		switch (attr) {
			case Event::QUANTITY: return(cev->CondorResourceUsage.quantity);
			default: goto badattr;
		}
		case PENDING:
		switch (attr) {
			default: goto badattr;
		}
		case REGJOB:
		switch (attr) {
			default: goto badattr;
		}
		case PBSINTERNALSTATECHANGE:
		switch (attr) {
			default: goto badattr;
		}
		case DISCONNECTJOB:
		switch (attr) {
			default: goto badattr;
		}
		case RESUME:
		switch (attr) {
			default: goto badattr;
		}
		case PBSQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		default:
		  STACK_ADD;
		  throw(Exception(EXCEPTION_MANDATORY, EINVAL,
				  "attribute is not of double type"));
        }
badattr:
        STACK_ADD;
        throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
	return -1; /* gcc, shut up! */
}

static char const *get_string_val(const edg_wll_Event *cev, Event::Attr attr)
{
	switch (attr) {
		case Event::USER: return(cev->any.user);
		case Event::SEQCODE: return(cev->any.seqcode);
		case Event::LEVEL: return((const char *)edg_wll_LevelToString((edg_wll_Level)cev->any.level));
		case Event::SRC_INSTANCE: return(cev->any.src_instance);
		case Event::HOST: return(cev->any.host);
		default: break;
	}

	switch (cev->type) {
		case Event::PBSPENDING:
		switch (attr) {
			case Event::REASON: return(cev->PBSPending.reason);
			default: goto badattr;
		}
		case Event::CLEAR:
		switch (attr) {
			case Event::REASON: return((const char *)edg_wll_ClearReasonToString(cev->clear.reason));
			default: goto badattr;
		}
		case Event::GRANTPAYLOADOWNERSHIP:
		switch (attr) {
			case Event::PAYLOAD_OWNER: return(cev->grantPayloadOwnership.payload_owner);
			default: goto badattr;
		}
		case Event::CONNECTJOB:
		switch (attr) {
			case Event::DEST_JOBID: return(cev->connectJob.dest_jobid);
			case Event::JOBTYPE: return((const char *)edg_wll_ConnectJobJobtypeToString(cev->connectJob.jobtype));
			default: goto badattr;
		}
		case Event::VMCREATE:
		switch (attr) {
			case Event::IMAGE: return(cev->vMCreate.image);
			case Event::OWNER: return(cev->vMCreate.owner);
			case Event::ID: return(cev->vMCreate.id);
			case Event::NAME: return(cev->vMCreate.name);
			case Event::MANAGER: return(cev->vMCreate.manager);
			case Event::REQUIRE: return(cev->vMCreate.require);
			case Event::HOSTNAME: return(cev->vMCreate.hostname);
			default: goto badattr;
		}
		case Event::CREAMACCEPTED:
		switch (attr) {
			case Event::LOCAL_JOBID: return(cev->CREAMAccepted.local_jobid);
			default: goto badattr;
		}
		case Event::TRANSFER:
		switch (attr) {
			case Event::JOB: return(cev->transfer.job);
			case Event::REASON: return(cev->transfer.reason);
			case Event::DEST_HOST: return(cev->transfer.dest_host);
			case Event::RESULT: return((const char *)edg_wll_TransferResultToString(cev->transfer.result));
			case Event::DEST_INSTANCE: return(cev->transfer.dest_instance);
			case Event::DEST_JOBID: return(cev->transfer.dest_jobid);
			default: goto badattr;
		}
		case Event::PBSACCEPTED:
		switch (attr) {
			case Event::FROM_INSTANCE: return(cev->PBSAccepted.from_instance);
			case Event::LOCAL_JOBID: return(cev->PBSAccepted.local_jobid);
			default: goto badattr;
		}
		case Event::PBSDONE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSWAITING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::RUNNING:
		switch (attr) {
			case Event::NODE: return(cev->running.node);
			default: goto badattr;
		}
		case Event::CURDESCR:
		switch (attr) {
			case Event::DESCR: return(cev->curDescr.descr);
			default: goto badattr;
		}
		case Event::SANDBOX:
		switch (attr) {
			case Event::SANDBOX_TYPE: return((const char *)edg_wll_SandboxSandbox_typeToString(cev->sandbox.sandbox_type));
			case Event::COMPUTE_JOB: return(cev->sandbox.compute_job);
			case Event::TRANSFER_JOB: return(cev->sandbox.transfer_job);
			default: goto badattr;
		}
		case Event::HELPERRETURN:
		switch (attr) {
			case Event::SRC_ROLE: return((const char *)edg_wll_HelperReturnSrc_roleToString(cev->helperReturn.src_role));
			case Event::RETVAL: return(cev->helperReturn.retval);
			case Event::HELPER_NAME: return(cev->helperReturn.helper_name);
			default: goto badattr;
		}
		case Event::PURGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORSHADOWEXITED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMRUNNING:
		switch (attr) {
			case Event::NODE: return(cev->CREAMRunning.node);
			default: goto badattr;
		}
		case Event::PBSRUN:
		switch (attr) {
			case Event::DEST_HOST: return(cev->PBSRun.dest_host);
			case Event::SCHEDULER: return(cev->PBSRun.scheduler);
			default: goto badattr;
		}
		case Event::CONDORREJECT:
		switch (attr) {
			case Event::STATUS_CODE: return((const char *)edg_wll_CondorRejectStatus_codeToString(cev->CondorReject.status_code));
			case Event::OWNER: return(cev->CondorReject.owner);
			default: goto badattr;
		}
		case Event::SUSPEND:
		switch (attr) {
			case Event::REASON: return(cev->suspend.reason);
			default: goto badattr;
		}
		case Event::CREAMRESUME:
		switch (attr) {
			case Event::REASON: return(cev->CREAMResume.reason);
			case Event::STATUS_CODE: return((const char *)edg_wll_CREAMResumeStatus_codeToString(cev->CREAMResume.status_code));
			default: goto badattr;
		}
		case Event::PBSRERUN:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSRESOURCEUSAGE:
		switch (attr) {
			case Event::USAGE: return((const char *)edg_wll_PBSResourceUsageUsageToString(cev->PBSResourceUsage.usage));
			default: goto badattr;
		}
		case Event::CHANGEACL:
		switch (attr) {
			case Event::USER_ID_TYPE: return((const char *)edg_wll_ChangeACLUser_id_typeToString(cev->changeACL.user_id_type));
			case Event::PERMISSION: return((const char *)edg_wll_ChangeACLPermissionToString(cev->changeACL.permission));
			case Event::OPERATION: return((const char *)edg_wll_ChangeACLOperationToString(cev->changeACL.operation));
			case Event::PERMISSION_TYPE: return((const char *)edg_wll_ChangeACLPermission_typeToString(cev->changeACL.permission_type));
			case Event::USER_ID: return(cev->changeACL.user_id);
			default: goto badattr;
		}
		case Event::CREAMSTART:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMSUSPEND:
		switch (attr) {
			case Event::REASON: return(cev->CREAMSuspend.reason);
			case Event::STATUS_CODE: return((const char *)edg_wll_CREAMSuspendStatus_codeToString(cev->CREAMSuspend.status_code));
			default: goto badattr;
		}
		case Event::CREAMDONE:
		switch (attr) {
			case Event::EXIT_CODE: return(cev->CREAMDone.exit_code);
			case Event::REASON: return(cev->CREAMDone.reason);
			case Event::STATUS_CODE: return((const char *)edg_wll_CREAMDoneStatus_codeToString(cev->CREAMDone.status_code));
			default: goto badattr;
		}
		case Event::CONDORSTARTERSTARTED:
		switch (attr) {
			case Event::UNIVERSE: return(cev->CondorStarterStarted.universe);
			default: goto badattr;
		}
		case Event::DONE:
		switch (attr) {
			case Event::REASON: return(cev->done.reason);
			case Event::STATUS_CODE: return((const char *)edg_wll_DoneStatus_codeToString(cev->done.status_code));
			default: goto badattr;
		}
		case Event::TAKEPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORMATCH:
		switch (attr) {
			case Event::OWNER: return(cev->CondorMatch.owner);
			case Event::DEST_HOST: return(cev->CondorMatch.dest_host);
			case Event::PREEMPTING: return(cev->CondorMatch.preempting);
			default: goto badattr;
		}
		case Event::CONDORSHADOWSTARTED:
		switch (attr) {
			case Event::SHADOW_HOST: return(cev->CondorShadowStarted.shadow_host);
			case Event::SHADOW_STATUS: return(cev->CondorShadowStarted.shadow_status);
			default: goto badattr;
		}
		case Event::FILETRANSFER:
		switch (attr) {
			case Event::RESULT: return((const char *)edg_wll_FileTransferResultToString(cev->fileTransfer.result));
			case Event::REASON: return(cev->fileTransfer.reason);
			default: goto badattr;
		}
		case Event::VMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::MATCH:
		switch (attr) {
			case Event::DEST_ID: return(cev->match.dest_id);
			default: goto badattr;
		}
		case Event::REFUSED:
		switch (attr) {
			case Event::FROM_HOST: return(cev->refused.from_host);
			case Event::REASON: return(cev->refused.reason);
			case Event::FROM_INSTANCE: return(cev->refused.from_instance);
			default: goto badattr;
		}
		case Event::CREAMREALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORSTARTEREXITED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMSTATUS:
		switch (attr) {
			case Event::FAILURE_REASON: return(cev->CREAMStatus.failure_reason);
			case Event::WORKER_NODE: return(cev->CREAMStatus.worker_node);
			case Event::RESULT: return((const char *)edg_wll_CREAMStatusResultToString(cev->CREAMStatus.result));
			case Event::DESCR: return(cev->CREAMStatus.descr);
			case Event::NEW_STATE: return(cev->CREAMStatus.new_state);
			case Event::OLD_STATE: return(cev->CREAMStatus.old_state);
			case Event::LRMS_JOBID: return(cev->CREAMStatus.LRMS_jobid);
			case Event::EXIT_CODE: return(cev->CREAMStatus.exit_code);
			default: goto badattr;
		}
		case Event::CONDORERROR:
		switch (attr) {
			case Event::ERROR_DESC: return(cev->CondorError.error_desc);
			default: goto badattr;
		}
		case Event::LISTENER:
		switch (attr) {
			case Event::SVC_NAME: return(cev->listener.svc_name);
			case Event::SVC_HOST: return(cev->listener.svc_host);
			default: goto badattr;
		}
		case Event::NOTIFICATION:
		switch (attr) {
			case Event::JOBSTAT: return(cev->notification.jobstat);
			case Event::OWNER: return(cev->notification.owner);
			case Event::DEST_HOST: return(cev->notification.dest_host);
			case Event::DEST_URL: return(cev->notification.dest_url);
			default: goto badattr;
		}
		case Event::VMSHUTDOWN:
		switch (attr) {
			case Event::USAGE: return(cev->vMShutdown.usage);
			default: goto badattr;
		}
		case Event::PBSABORT:
		switch (attr) {
			default: goto badattr;
		}
		case Event::ACCEPTED:
		switch (attr) {
			case Event::FROM_INSTANCE: return(cev->accepted.from_instance);
			case Event::LOCAL_JOBID: return(cev->accepted.local_jobid);
			case Event::FROM_HOST: return(cev->accepted.from_host);
			default: goto badattr;
		}
		case Event::VMSTOP:
		switch (attr) {
			default: goto badattr;
		}
		case Event::RESOURCEUSAGE:
		switch (attr) {
			case Event::UNIT: return(cev->resourceUsage.unit);
			case Event::RESOURCE: return(cev->resourceUsage.resource);
			default: goto badattr;
		}
		case Event::CANCEL:
		switch (attr) {
			case Event::REASON: return(cev->cancel.reason);
			case Event::STATUS_CODE: return((const char *)edg_wll_CancelStatus_codeToString(cev->cancel.status_code));
			default: goto badattr;
		}
		case Event::PBSTRANSFER:
		switch (attr) {
			case Event::DEST_INSTANCE: return(cev->PBSTransfer.dest_instance);
			case Event::DEST_JOBID: return(cev->PBSTransfer.dest_jobid);
			case Event::RESULT: return((const char *)edg_wll_PBSTransferResultToString(cev->PBSTransfer.result));
			case Event::REASON: return(cev->PBSTransfer.reason);
			default: goto badattr;
		}
		case Event::CREAMCALL:
		switch (attr) {
			case Event::RESULT: return((const char *)edg_wll_CREAMCallResultToString(cev->CREAMCall.result));
			case Event::COMMAND: return((const char *)edg_wll_CREAMCallCommandToString(cev->CREAMCall.command));
			case Event::REASON: return(cev->CREAMCall.reason);
			case Event::DESTID: return(cev->CREAMCall.destid);
			case Event::CMDID: return(cev->CREAMCall.cmdid);
			default: goto badattr;
		}
		case Event::VMRESUME:
		switch (attr) {
			default: goto badattr;
		}
		case Event::HELPERCALL:
		switch (attr) {
			case Event::HELPER_NAME: return(cev->helperCall.helper_name);
			case Event::SRC_ROLE: return((const char *)edg_wll_HelperCallSrc_roleToString(cev->helperCall.src_role));
			case Event::HELPER_PARAMS: return(cev->helperCall.helper_params);
			default: goto badattr;
		}
		case Event::PBSERROR:
		switch (attr) {
			case Event::ERROR_DESC: return(cev->PBSError.error_desc);
			default: goto badattr;
		}
		case Event::COLLECTIONSTATE:
		switch (attr) {
			case Event::CHILD_EVENT: return(cev->collectionState.child_event);
			case Event::HISTOGRAM: return(cev->collectionState.histogram);
			case Event::STATE: return(cev->collectionState.state);
			default: goto badattr;
		}
		case Event::ABORT:
		switch (attr) {
			case Event::REASON: return(cev->abort.reason);
			default: goto badattr;
		}
		case Event::ENQUEUED:
		switch (attr) {
			case Event::REASON: return(cev->enQueued.reason);
			case Event::QUEUE: return(cev->enQueued.queue);
			case Event::JOB: return(cev->enQueued.job);
			case Event::RESULT: return((const char *)edg_wll_EnQueuedResultToString(cev->enQueued.result));
			default: goto badattr;
		}
		case Event::USERTAG:
		switch (attr) {
			case Event::VALUE: return(cev->userTag.value);
			case Event::NAME: return(cev->userTag.name);
			default: goto badattr;
		}
		case Event::REALLYRUNNING:
		switch (attr) {
			case Event::WN_SEQ: return(cev->reallyRunning.wn_seq);
			default: goto badattr;
		}
		case Event::VMHOST:
		switch (attr) {
			case Event::HOSTNAME: return(cev->vMHost.hostname);
			default: goto badattr;
		}
		case Event::VMIMAGE:
		switch (attr) {
			case Event::IMAGE: return(cev->vMImage.image);
			default: goto badattr;
		}
		case Event::CREAMSTORE:
		switch (attr) {
			case Event::CMDID: return(cev->CREAMStore.cmdid);
			case Event::REASON: return(cev->CREAMStore.reason);
			case Event::COMMAND: return((const char *)edg_wll_CREAMStoreCommandToString(cev->CREAMStore.command));
			case Event::RESULT: return((const char *)edg_wll_CREAMStoreResultToString(cev->CREAMStore.result));
			default: goto badattr;
		}
		case Event::CHKPT:
		switch (attr) {
			case Event::TAG: return(cev->chkpt.tag);
			case Event::CLASSAD: return(cev->chkpt.classad);
			default: goto badattr;
		}
		case Event::CREAMPURGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSMATCH:
		switch (attr) {
			case Event::DEST_HOST: return(cev->PBSMatch.dest_host);
			default: goto badattr;
		}
		case Event::DEQUEUED:
		switch (attr) {
			case Event::LOCAL_JOBID: return(cev->deQueued.local_jobid);
			case Event::QUEUE: return(cev->deQueued.queue);
			default: goto badattr;
		}
		case Event::CREAMABORT:
		switch (attr) {
			case Event::REASON: return(cev->CREAMAbort.reason);
			default: goto badattr;
		}
		case Event::PBSDEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::FILETRANSFERREGISTER:
		switch (attr) {
			case Event::SRC: return(cev->fileTransferRegister.src);
			case Event::DEST: return(cev->fileTransferRegister.dest);
			default: goto badattr;
		}
		case Event::RESUBMISSION:
		switch (attr) {
			case Event::REASON: return(cev->resubmission.reason);
			case Event::RESULT: return((const char *)edg_wll_ResubmissionResultToString(cev->resubmission.result));
			case Event::TAG: return(cev->resubmission.tag);
			default: goto badattr;
		}
		case Event::CREAMCANCEL:
		switch (attr) {
			case Event::REASON: return(cev->CREAMCancel.reason);
			case Event::STATUS_CODE: return((const char *)edg_wll_CREAMCancelStatus_codeToString(cev->CREAMCancel.status_code));
			default: goto badattr;
		}
		case Event::PBSREFUSED:
		switch (attr) {
			case Event::REASON: return(cev->PBSRefused.reason);
			case Event::FROM_INSTANCE: return(cev->PBSRefused.from_instance);
			default: goto badattr;
		}
		case Event::VMDONE:
		switch (attr) {
			case Event::STATUS_CODE: return((const char *)edg_wll_VMDoneStatus_codeToString(cev->vMDone.status_code));
			case Event::USAGE: return(cev->vMDone.usage);
			default: goto badattr;
		}
		case Event::CONDORRESOURCEUSAGE:
		switch (attr) {
			case Event::USAGE: return((const char *)edg_wll_CondorResourceUsageUsageToString(cev->CondorResourceUsage.usage));
			case Event::NAME: return(cev->CondorResourceUsage.name);
			case Event::UNIT: return(cev->CondorResourceUsage.unit);
			default: goto badattr;
		}
		case Event::PENDING:
		switch (attr) {
			case Event::REASON: return(cev->pending.reason);
			default: goto badattr;
		}
		case Event::REGJOB:
		switch (attr) {
			case Event::JOBTYPE: return((const char *)edg_wll_RegJobJobtypeToString(cev->regJob.jobtype));
			case Event::NS: return(cev->regJob.ns);
			case Event::JDL: return(cev->regJob.jdl);
			case Event::SEED: return(cev->regJob.seed);
			case Event::WMS_DN: return(cev->regJob.wms_dn);
			default: goto badattr;
		}
		case Event::PBSINTERNALSTATECHANGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::DISCONNECTJOB:
		switch (attr) {
			case Event::DEST_JOBID: return(cev->disconnectJob.dest_jobid);
			default: goto badattr;
		}
		case Event::RESUME:
		switch (attr) {
			case Event::REASON: return(cev->resume.reason);
			default: goto badattr;
		}
		case Event::PBSQUEUED:
		switch (attr) {
			case Event::QUEUE: return(cev->PBSQueued.queue);
			case Event::OWNER: return(cev->PBSQueued.owner);
			case Event::NAME: return(cev->PBSQueued.name);
			default: goto badattr;
		}
		default:
		  STACK_ADD;
		  throw(Exception(EXCEPTION_MANDATORY, EINVAL, 
				  "attribute is not of string type and can not be converted"));
	}
badattr:
	STACK_ADD;
	throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
	return NULL; /* gcc, shut up! */
}


std::string 
Event::getValString(Attr attr) const
{
  edg_wll_Event const *cev = (edg_wll_Event *) flesh->ptr;
  std::string	ret;
  
  try {
    char const	*s = get_string_val(cev,attr);
    if (s) ret.assign(s);
    return ret;
  } catch (Exception &e) {
    STACK_ADD;
    throw;
  }
}


struct timeval 
Event::getValTime(Attr attr) const
{
  edg_wll_Event const *cev = (edg_wll_Event *) flesh->ptr;
	switch (attr) {
		case Event::ARRIVED: return(cev->any.arrived);
		case Event::TIMESTAMP: return(cev->any.timestamp);
		default: break;
	}
  
  /* XXX
   * to make things simpler we don't include this here as there are no
   * type specific timeval attributes currently
   *
   *	switch (cev->type) {
   */

  STACK_ADD; 
  throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
}

static
edg_wlc_JobId 
get_val_jobid(edg_wll_Event const *cev, Event::Attr attr) 
{
	switch (attr) {
		case Event::JOBID: return(cev->any.jobId);
		default: break;
	}
	switch (cev->type) {
		case Event::PBSPENDING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CLEAR:
		switch (attr) {
			default: goto badattr;
		}
		case Event::GRANTPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONNECTJOB:
		switch (attr) {
			default: goto badattr;
		}
		case Event::VMCREATE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::TRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSDONE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSWAITING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::RUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CURDESCR:
		switch (attr) {
			default: goto badattr;
		}
		case Event::SANDBOX:
		switch (attr) {
			default: goto badattr;
		}
		case Event::HELPERRETURN:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PURGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORSHADOWEXITED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSRUN:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORREJECT:
		switch (attr) {
			default: goto badattr;
		}
		case Event::SUSPEND:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMRESUME:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSRERUN:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSRESOURCEUSAGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CHANGEACL:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMSTART:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMSUSPEND:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMDONE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORSTARTERSTARTED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::DONE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::TAKEPAYLOADOWNERSHIP:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORMATCH:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORSHADOWSTARTED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::FILETRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case Event::VMRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::MATCH:
		switch (attr) {
			default: goto badattr;
		}
		case Event::REFUSED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMREALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORSTARTEREXITED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMSTATUS:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORERROR:
		switch (attr) {
			default: goto badattr;
		}
		case Event::LISTENER:
		switch (attr) {
			default: goto badattr;
		}
		case Event::NOTIFICATION:
		switch (attr) {
			default: goto badattr;
		}
		case Event::VMSHUTDOWN:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSABORT:
		switch (attr) {
			default: goto badattr;
		}
		case Event::ACCEPTED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::VMSTOP:
		switch (attr) {
			default: goto badattr;
		}
		case Event::RESOURCEUSAGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CANCEL:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSTRANSFER:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMCALL:
		switch (attr) {
			default: goto badattr;
		}
		case Event::VMRESUME:
		switch (attr) {
			default: goto badattr;
		}
		case Event::HELPERCALL:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSERROR:
		switch (attr) {
			default: goto badattr;
		}
		case Event::COLLECTIONSTATE:
		switch (attr) {
			case Event::CHILD: return(cev->collectionState.child);
			default: goto badattr;
		}
		case Event::ABORT:
		switch (attr) {
			default: goto badattr;
		}
		case Event::ENQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::USERTAG:
		switch (attr) {
			default: goto badattr;
		}
		case Event::REALLYRUNNING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::VMHOST:
		switch (attr) {
			default: goto badattr;
		}
		case Event::VMIMAGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMSTORE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CHKPT:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMPURGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSMATCH:
		switch (attr) {
			default: goto badattr;
		}
		case Event::DEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMABORT:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSDEQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::FILETRANSFERREGISTER:
		switch (attr) {
			default: goto badattr;
		}
		case Event::RESUBMISSION:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CREAMCANCEL:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSREFUSED:
		switch (attr) {
			default: goto badattr;
		}
		case Event::VMDONE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::CONDORRESOURCEUSAGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PENDING:
		switch (attr) {
			default: goto badattr;
		}
		case Event::REGJOB:
		switch (attr) {
			case Event::PARENT: return(cev->regJob.parent);
			default: goto badattr;
		}
		case Event::PBSINTERNALSTATECHANGE:
		switch (attr) {
			default: goto badattr;
		}
		case Event::DISCONNECTJOB:
		switch (attr) {
			default: goto badattr;
		}
		case Event::RESUME:
		switch (attr) {
			default: goto badattr;
		}
		case Event::PBSQUEUED:
		switch (attr) {
			default: goto badattr;
		}
		default:
		  STACK_ADD;
		  throw(Exception(EXCEPTION_MANDATORY, EINVAL, 
				  "attribute is not of jobid type"));
	}
badattr:
	STACK_ADD;
	throw(Exception(EXCEPTION_MANDATORY, ENOENT, "invalid attribute"));
	return NULL; /* gcc, shut up! */
}

const 
glite::jobid::JobId 
Event::getValJobId(Attr attr) const
{
	edg_wll_Event const *cev = (edg_wll_Event *) flesh->ptr;
	try {
		edg_wlc_JobId job_id = get_val_jobid(cev,attr);
		return(glite::jobid::JobId(job_id));
	} 
	catch (Exception &e) {
		STACK_ADD;
		throw;
	}

}


static std::string const names[Event::TYPE_MAX] = {
	"undefined",
	"Transfer",
	"Accepted",
	"Refused",
	"EnQueued",
	"DeQueued",
	"HelperCall",
	"HelperReturn",
	"Running",
	"Resubmission",
	"Done",
	"Cancel",
	"Abort",
	"Clear",
	"Purge",
	"Match",
	"Pending",
	"RegJob",
	"Chkpt",
	"Listener",
	"CurDescr",
	"UserTag",
	"ChangeACL",
	"Notification",
	"ResourceUsage",
	"ReallyRunning",
	"Suspend",
	"Resume",
	"CollectionState",
	"GrantPayloadOwnership",
	"TakePayloadOwnership",
	"ConnectJob",
	"DisconnectJob",
	"PBSInternalStateChange",
	"PBSTransfer",
	"PBSAccepted",
	"PBSRefused",
	"PBSQueued",
	"PBSDequeued",
	"PBSMatch",
	"PBSPending",
	"PBSWaiting",
	"PBSRun",
	"PBSRerun",
	"PBSAbort",
	"PBSDone",
	"PBSResourceUsage",
	"PBSError",
	"CondorMatch",
	"CondorReject",
	"CondorShadowStarted",
	"CondorShadowExited",
	"CondorStarterStarted",
	"CondorStarterExited",
	"CondorResourceUsage",
	"CondorError",
	"CREAMStart",
	"CREAMPurge",
	"CREAMAccepted",
	"CREAMStore",
	"CREAMCall",
	"CREAMRunning",
	"CREAMReallyRunning",
	"CREAMDone",
	"CREAMCancel",
	"CREAMAbort",
	"CREAMStatus",
	"CREAMSuspend",
	"CREAMResume",
	"FileTransferRegister",
	"FileTransfer",
	"Sandbox",
	"VMCreate",
	"VMHost",
	"VMImage",
	"VMRunning",
	"VMShutdown",
	"VMStop",
	"VMResume",
	"VMDone",
};

const std::string  & 
Event::name(void) const
{
  if (type<0 || type>TYPE_MAX) {
    STACK_ADD;
    throw(Exception(EXCEPTION_MANDATORY, EINVAL, "invalid event type"));
  }
  return names[type];
}


static 
std::string const attr_names[Event::ATTR_MAX] = {
	"arrived",
	"child",
	"child_event",
	"classad",
	"descr",
	"dest_host",
	"dest_id",
	"dest_instance",
	"dest_jobid",
	"dest_port",
	"destination",
	"done_code",
	"error_desc",
	"exit_code",
	"exit_status",
	"from",
	"from_host",
	"from_instance",
	"helper_name",
	"helper_params",
	"histogram",
	"host",
	"jdl",
	"job",
	"jobId",
	"job_exit_status",
	"job_pid",
	"jobstat",
	"jobtype",
	"level",
	"local_jobid",
	"name",
	"node",
	"notifId",
	"ns",
	"nsubjobs",
	"operation",
	"owner",
	"parent",
	"permission",
	"permission_type",
	"pid",
	"preempting",
	"priority",
	"quantity",
	"queue",
	"reason",
	"resource",
	"result",
	"retval",
	"scheduler",
	"seed",
	"seqcode",
	"shadow_exit_status",
	"shadow_host",
	"shadow_pid",
	"shadow_port",
	"shadow_status",
	"source",
	"src_instance",
	"src_role",
	"starter_exit_status",
	"starter_pid",
	"state",
	"status_code",
	"svc_host",
	"svc_name",
	"svc_port",
	"tag",
	"timestamp",
	"unit",
	"universe",
	"usage",
	"user",
	"user_id",
	"user_id_type",
	"value",
	"wn_seq",
	"expires",
	"command",
	"cmdid",
	"callee",
	"destid",
	"new_state",
	"old_state",
	"orig_timestamp",
	"src",
	"dest",
	"sandbox_type",
	"transfer_job",
	"compute_job",
	"dest_url",
	"LRMS_jobid",
	"worker_node",
	"failure_reason",
	"wms_dn",
	"payload_owner",
	"oldstate",
	"oldsubstate",
	"newstate",
	"newsubstate",
	"resources",
	"image",
	"require",
	"hostname",
	"id",
	"manager",
};

const std::string & 
Event::getAttrName(Attr attr)
{
  if (attr<0 || attr>=ATTR_MAX) {
    STACK_ADD;
    throw(Exception(EXCEPTION_MANDATORY, EINVAL, "invalid attribute"));
  }
  return attr_names[attr];
}


typedef std::pair<Event::Attr,Event::AttrType> tpair;
static std::vector<tpair> attrs[Event::TYPE_MAX];

#define apush(etype,attr,atype) \
	attrs[etype].push_back(tpair(attr,atype))

static bool attrs_inited = false;

static void init_attrs(void)
{
	apush(Event::PBSPENDING,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSPENDING,Event::USER,Event::STRING_T);
	apush(Event::PBSPENDING,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSPENDING,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSPENDING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSPENDING,Event::LEVEL,Event::INT_T);
	apush(Event::PBSPENDING,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSPENDING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSPENDING,Event::HOST,Event::STRING_T);
	apush(Event::PBSPENDING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSPENDING,Event::REASON,Event::STRING_T);
	apush(Event::CLEAR,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CLEAR,Event::USER,Event::STRING_T);
	apush(Event::CLEAR,Event::SEQCODE,Event::STRING_T);
	apush(Event::CLEAR,Event::JOBID,Event::JOBID_T);
	apush(Event::CLEAR,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CLEAR,Event::LEVEL,Event::INT_T);
	apush(Event::CLEAR,Event::PRIORITY,Event::INT_T);
	apush(Event::CLEAR,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CLEAR,Event::HOST,Event::STRING_T);
	apush(Event::CLEAR,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CLEAR,Event::REASON,Event::INT_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::USER,Event::STRING_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::SEQCODE,Event::STRING_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::JOBID,Event::JOBID_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::LEVEL,Event::INT_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::PRIORITY,Event::INT_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::HOST,Event::STRING_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::GRANTPAYLOADOWNERSHIP,Event::PAYLOAD_OWNER,Event::STRING_T);
	apush(Event::CONNECTJOB,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONNECTJOB,Event::USER,Event::STRING_T);
	apush(Event::CONNECTJOB,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONNECTJOB,Event::JOBID,Event::JOBID_T);
	apush(Event::CONNECTJOB,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONNECTJOB,Event::LEVEL,Event::INT_T);
	apush(Event::CONNECTJOB,Event::PRIORITY,Event::INT_T);
	apush(Event::CONNECTJOB,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONNECTJOB,Event::HOST,Event::STRING_T);
	apush(Event::CONNECTJOB,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONNECTJOB,Event::DEST_JOBID,Event::STRING_T);
	apush(Event::CONNECTJOB,Event::JOBTYPE,Event::INT_T);
	apush(Event::VMCREATE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::VMCREATE,Event::USER,Event::STRING_T);
	apush(Event::VMCREATE,Event::SEQCODE,Event::STRING_T);
	apush(Event::VMCREATE,Event::JOBID,Event::JOBID_T);
	apush(Event::VMCREATE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::VMCREATE,Event::LEVEL,Event::INT_T);
	apush(Event::VMCREATE,Event::PRIORITY,Event::INT_T);
	apush(Event::VMCREATE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::VMCREATE,Event::HOST,Event::STRING_T);
	apush(Event::VMCREATE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::VMCREATE,Event::IMAGE,Event::STRING_T);
	apush(Event::VMCREATE,Event::OWNER,Event::STRING_T);
	apush(Event::VMCREATE,Event::ID,Event::STRING_T);
	apush(Event::VMCREATE,Event::NAME,Event::STRING_T);
	apush(Event::VMCREATE,Event::MANAGER,Event::STRING_T);
	apush(Event::VMCREATE,Event::REQUIRE,Event::STRING_T);
	apush(Event::VMCREATE,Event::HOSTNAME,Event::STRING_T);
	apush(Event::CREAMACCEPTED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMACCEPTED,Event::USER,Event::STRING_T);
	apush(Event::CREAMACCEPTED,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMACCEPTED,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMACCEPTED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMACCEPTED,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMACCEPTED,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMACCEPTED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMACCEPTED,Event::HOST,Event::STRING_T);
	apush(Event::CREAMACCEPTED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMACCEPTED,Event::LOCAL_JOBID,Event::STRING_T);
	apush(Event::TRANSFER,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::TRANSFER,Event::USER,Event::STRING_T);
	apush(Event::TRANSFER,Event::SEQCODE,Event::STRING_T);
	apush(Event::TRANSFER,Event::JOBID,Event::JOBID_T);
	apush(Event::TRANSFER,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::TRANSFER,Event::LEVEL,Event::INT_T);
	apush(Event::TRANSFER,Event::PRIORITY,Event::INT_T);
	apush(Event::TRANSFER,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::TRANSFER,Event::HOST,Event::STRING_T);
	apush(Event::TRANSFER,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::TRANSFER,Event::JOB,Event::STRING_T);
	apush(Event::TRANSFER,Event::REASON,Event::STRING_T);
	apush(Event::TRANSFER,Event::DEST_HOST,Event::STRING_T);
	apush(Event::TRANSFER,Event::RESULT,Event::INT_T);
	apush(Event::TRANSFER,Event::DESTINATION,Event::LOGSRC_T);
	apush(Event::TRANSFER,Event::DEST_INSTANCE,Event::STRING_T);
	apush(Event::TRANSFER,Event::DEST_JOBID,Event::STRING_T);
	apush(Event::PBSACCEPTED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSACCEPTED,Event::USER,Event::STRING_T);
	apush(Event::PBSACCEPTED,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSACCEPTED,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSACCEPTED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSACCEPTED,Event::LEVEL,Event::INT_T);
	apush(Event::PBSACCEPTED,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSACCEPTED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSACCEPTED,Event::HOST,Event::STRING_T);
	apush(Event::PBSACCEPTED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSACCEPTED,Event::FROM_INSTANCE,Event::STRING_T);
	apush(Event::PBSACCEPTED,Event::LOCAL_JOBID,Event::STRING_T);
	apush(Event::PBSACCEPTED,Event::FROM,Event::LOGSRC_T);
	apush(Event::PBSDONE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSDONE,Event::USER,Event::STRING_T);
	apush(Event::PBSDONE,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSDONE,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSDONE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSDONE,Event::LEVEL,Event::INT_T);
	apush(Event::PBSDONE,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSDONE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSDONE,Event::HOST,Event::STRING_T);
	apush(Event::PBSDONE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSDONE,Event::EXIT_STATUS,Event::INT_T);
	apush(Event::PBSWAITING,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSWAITING,Event::USER,Event::STRING_T);
	apush(Event::PBSWAITING,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSWAITING,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSWAITING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSWAITING,Event::LEVEL,Event::INT_T);
	apush(Event::PBSWAITING,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSWAITING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSWAITING,Event::HOST,Event::STRING_T);
	apush(Event::PBSWAITING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::RUNNING,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::RUNNING,Event::USER,Event::STRING_T);
	apush(Event::RUNNING,Event::SEQCODE,Event::STRING_T);
	apush(Event::RUNNING,Event::JOBID,Event::JOBID_T);
	apush(Event::RUNNING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::RUNNING,Event::LEVEL,Event::INT_T);
	apush(Event::RUNNING,Event::PRIORITY,Event::INT_T);
	apush(Event::RUNNING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::RUNNING,Event::HOST,Event::STRING_T);
	apush(Event::RUNNING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::RUNNING,Event::NODE,Event::STRING_T);
	apush(Event::CURDESCR,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CURDESCR,Event::USER,Event::STRING_T);
	apush(Event::CURDESCR,Event::SEQCODE,Event::STRING_T);
	apush(Event::CURDESCR,Event::JOBID,Event::JOBID_T);
	apush(Event::CURDESCR,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CURDESCR,Event::LEVEL,Event::INT_T);
	apush(Event::CURDESCR,Event::PRIORITY,Event::INT_T);
	apush(Event::CURDESCR,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CURDESCR,Event::HOST,Event::STRING_T);
	apush(Event::CURDESCR,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CURDESCR,Event::DESCR,Event::STRING_T);
	apush(Event::SANDBOX,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::SANDBOX,Event::USER,Event::STRING_T);
	apush(Event::SANDBOX,Event::SEQCODE,Event::STRING_T);
	apush(Event::SANDBOX,Event::JOBID,Event::JOBID_T);
	apush(Event::SANDBOX,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::SANDBOX,Event::LEVEL,Event::INT_T);
	apush(Event::SANDBOX,Event::PRIORITY,Event::INT_T);
	apush(Event::SANDBOX,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::SANDBOX,Event::HOST,Event::STRING_T);
	apush(Event::SANDBOX,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::SANDBOX,Event::SANDBOX_TYPE,Event::INT_T);
	apush(Event::SANDBOX,Event::COMPUTE_JOB,Event::STRING_T);
	apush(Event::SANDBOX,Event::TRANSFER_JOB,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::HELPERRETURN,Event::USER,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::SEQCODE,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::JOBID,Event::JOBID_T);
	apush(Event::HELPERRETURN,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::HELPERRETURN,Event::LEVEL,Event::INT_T);
	apush(Event::HELPERRETURN,Event::PRIORITY,Event::INT_T);
	apush(Event::HELPERRETURN,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::HOST,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::HELPERRETURN,Event::SRC_ROLE,Event::INT_T);
	apush(Event::HELPERRETURN,Event::RETVAL,Event::STRING_T);
	apush(Event::HELPERRETURN,Event::HELPER_NAME,Event::STRING_T);
	apush(Event::PURGE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PURGE,Event::USER,Event::STRING_T);
	apush(Event::PURGE,Event::SEQCODE,Event::STRING_T);
	apush(Event::PURGE,Event::JOBID,Event::JOBID_T);
	apush(Event::PURGE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PURGE,Event::LEVEL,Event::INT_T);
	apush(Event::PURGE,Event::PRIORITY,Event::INT_T);
	apush(Event::PURGE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PURGE,Event::HOST,Event::STRING_T);
	apush(Event::PURGE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORSHADOWEXITED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONDORSHADOWEXITED,Event::USER,Event::STRING_T);
	apush(Event::CONDORSHADOWEXITED,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONDORSHADOWEXITED,Event::JOBID,Event::JOBID_T);
	apush(Event::CONDORSHADOWEXITED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONDORSHADOWEXITED,Event::LEVEL,Event::INT_T);
	apush(Event::CONDORSHADOWEXITED,Event::PRIORITY,Event::INT_T);
	apush(Event::CONDORSHADOWEXITED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONDORSHADOWEXITED,Event::HOST,Event::STRING_T);
	apush(Event::CONDORSHADOWEXITED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORSHADOWEXITED,Event::SHADOW_EXIT_STATUS,Event::INT_T);
	apush(Event::CONDORSHADOWEXITED,Event::SHADOW_PID,Event::INT_T);
	apush(Event::CREAMRUNNING,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMRUNNING,Event::USER,Event::STRING_T);
	apush(Event::CREAMRUNNING,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMRUNNING,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMRUNNING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMRUNNING,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMRUNNING,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMRUNNING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMRUNNING,Event::HOST,Event::STRING_T);
	apush(Event::CREAMRUNNING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMRUNNING,Event::NODE,Event::STRING_T);
	apush(Event::PBSRUN,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSRUN,Event::USER,Event::STRING_T);
	apush(Event::PBSRUN,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSRUN,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSRUN,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSRUN,Event::LEVEL,Event::INT_T);
	apush(Event::PBSRUN,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSRUN,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSRUN,Event::HOST,Event::STRING_T);
	apush(Event::PBSRUN,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSRUN,Event::PID,Event::INT_T);
	apush(Event::PBSRUN,Event::DEST_HOST,Event::STRING_T);
	apush(Event::PBSRUN,Event::SCHEDULER,Event::STRING_T);
	apush(Event::CONDORREJECT,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONDORREJECT,Event::USER,Event::STRING_T);
	apush(Event::CONDORREJECT,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONDORREJECT,Event::JOBID,Event::JOBID_T);
	apush(Event::CONDORREJECT,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONDORREJECT,Event::LEVEL,Event::INT_T);
	apush(Event::CONDORREJECT,Event::PRIORITY,Event::INT_T);
	apush(Event::CONDORREJECT,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONDORREJECT,Event::HOST,Event::STRING_T);
	apush(Event::CONDORREJECT,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORREJECT,Event::STATUS_CODE,Event::INT_T);
	apush(Event::CONDORREJECT,Event::OWNER,Event::STRING_T);
	apush(Event::SUSPEND,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::SUSPEND,Event::USER,Event::STRING_T);
	apush(Event::SUSPEND,Event::SEQCODE,Event::STRING_T);
	apush(Event::SUSPEND,Event::JOBID,Event::JOBID_T);
	apush(Event::SUSPEND,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::SUSPEND,Event::LEVEL,Event::INT_T);
	apush(Event::SUSPEND,Event::PRIORITY,Event::INT_T);
	apush(Event::SUSPEND,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::SUSPEND,Event::HOST,Event::STRING_T);
	apush(Event::SUSPEND,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::SUSPEND,Event::REASON,Event::STRING_T);
	apush(Event::CREAMRESUME,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMRESUME,Event::USER,Event::STRING_T);
	apush(Event::CREAMRESUME,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMRESUME,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMRESUME,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMRESUME,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMRESUME,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMRESUME,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMRESUME,Event::HOST,Event::STRING_T);
	apush(Event::CREAMRESUME,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMRESUME,Event::REASON,Event::STRING_T);
	apush(Event::CREAMRESUME,Event::STATUS_CODE,Event::INT_T);
	apush(Event::PBSRERUN,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSRERUN,Event::USER,Event::STRING_T);
	apush(Event::PBSRERUN,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSRERUN,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSRERUN,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSRERUN,Event::LEVEL,Event::INT_T);
	apush(Event::PBSRERUN,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSRERUN,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSRERUN,Event::HOST,Event::STRING_T);
	apush(Event::PBSRERUN,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSRESOURCEUSAGE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSRESOURCEUSAGE,Event::USER,Event::STRING_T);
	apush(Event::PBSRESOURCEUSAGE,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSRESOURCEUSAGE,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSRESOURCEUSAGE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSRESOURCEUSAGE,Event::LEVEL,Event::INT_T);
	apush(Event::PBSRESOURCEUSAGE,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSRESOURCEUSAGE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSRESOURCEUSAGE,Event::HOST,Event::STRING_T);
	apush(Event::PBSRESOURCEUSAGE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSRESOURCEUSAGE,Event::RESOURCES,Event::TAGLIST_T);
	apush(Event::PBSRESOURCEUSAGE,Event::USAGE,Event::INT_T);
	apush(Event::CHANGEACL,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CHANGEACL,Event::USER,Event::STRING_T);
	apush(Event::CHANGEACL,Event::SEQCODE,Event::STRING_T);
	apush(Event::CHANGEACL,Event::JOBID,Event::JOBID_T);
	apush(Event::CHANGEACL,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CHANGEACL,Event::LEVEL,Event::INT_T);
	apush(Event::CHANGEACL,Event::PRIORITY,Event::INT_T);
	apush(Event::CHANGEACL,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CHANGEACL,Event::HOST,Event::STRING_T);
	apush(Event::CHANGEACL,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CHANGEACL,Event::USER_ID_TYPE,Event::INT_T);
	apush(Event::CHANGEACL,Event::PERMISSION,Event::INT_T);
	apush(Event::CHANGEACL,Event::OPERATION,Event::INT_T);
	apush(Event::CHANGEACL,Event::PERMISSION_TYPE,Event::INT_T);
	apush(Event::CHANGEACL,Event::USER_ID,Event::STRING_T);
	apush(Event::CREAMSTART,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMSTART,Event::USER,Event::STRING_T);
	apush(Event::CREAMSTART,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMSTART,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMSTART,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMSTART,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMSTART,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMSTART,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMSTART,Event::HOST,Event::STRING_T);
	apush(Event::CREAMSTART,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMSUSPEND,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMSUSPEND,Event::USER,Event::STRING_T);
	apush(Event::CREAMSUSPEND,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMSUSPEND,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMSUSPEND,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMSUSPEND,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMSUSPEND,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMSUSPEND,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMSUSPEND,Event::HOST,Event::STRING_T);
	apush(Event::CREAMSUSPEND,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMSUSPEND,Event::REASON,Event::STRING_T);
	apush(Event::CREAMSUSPEND,Event::STATUS_CODE,Event::INT_T);
	apush(Event::CREAMDONE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMDONE,Event::USER,Event::STRING_T);
	apush(Event::CREAMDONE,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMDONE,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMDONE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMDONE,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMDONE,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMDONE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMDONE,Event::HOST,Event::STRING_T);
	apush(Event::CREAMDONE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMDONE,Event::EXIT_CODE,Event::STRING_T);
	apush(Event::CREAMDONE,Event::REASON,Event::STRING_T);
	apush(Event::CREAMDONE,Event::STATUS_CODE,Event::INT_T);
	apush(Event::CONDORSTARTERSTARTED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONDORSTARTERSTARTED,Event::USER,Event::STRING_T);
	apush(Event::CONDORSTARTERSTARTED,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONDORSTARTERSTARTED,Event::JOBID,Event::JOBID_T);
	apush(Event::CONDORSTARTERSTARTED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONDORSTARTERSTARTED,Event::LEVEL,Event::INT_T);
	apush(Event::CONDORSTARTERSTARTED,Event::PRIORITY,Event::INT_T);
	apush(Event::CONDORSTARTERSTARTED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONDORSTARTERSTARTED,Event::HOST,Event::STRING_T);
	apush(Event::CONDORSTARTERSTARTED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORSTARTERSTARTED,Event::UNIVERSE,Event::STRING_T);
	apush(Event::CONDORSTARTERSTARTED,Event::STARTER_PID,Event::INT_T);
	apush(Event::DONE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::DONE,Event::USER,Event::STRING_T);
	apush(Event::DONE,Event::SEQCODE,Event::STRING_T);
	apush(Event::DONE,Event::JOBID,Event::JOBID_T);
	apush(Event::DONE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::DONE,Event::LEVEL,Event::INT_T);
	apush(Event::DONE,Event::PRIORITY,Event::INT_T);
	apush(Event::DONE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::DONE,Event::HOST,Event::STRING_T);
	apush(Event::DONE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::DONE,Event::REASON,Event::STRING_T);
	apush(Event::DONE,Event::STATUS_CODE,Event::INT_T);
	apush(Event::DONE,Event::EXIT_CODE,Event::INT_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::USER,Event::STRING_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::SEQCODE,Event::STRING_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::JOBID,Event::JOBID_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::LEVEL,Event::INT_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::PRIORITY,Event::INT_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::HOST,Event::STRING_T);
	apush(Event::TAKEPAYLOADOWNERSHIP,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORMATCH,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONDORMATCH,Event::USER,Event::STRING_T);
	apush(Event::CONDORMATCH,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONDORMATCH,Event::JOBID,Event::JOBID_T);
	apush(Event::CONDORMATCH,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONDORMATCH,Event::LEVEL,Event::INT_T);
	apush(Event::CONDORMATCH,Event::PRIORITY,Event::INT_T);
	apush(Event::CONDORMATCH,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONDORMATCH,Event::HOST,Event::STRING_T);
	apush(Event::CONDORMATCH,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORMATCH,Event::OWNER,Event::STRING_T);
	apush(Event::CONDORMATCH,Event::DEST_HOST,Event::STRING_T);
	apush(Event::CONDORMATCH,Event::PREEMPTING,Event::STRING_T);
	apush(Event::CONDORSHADOWSTARTED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONDORSHADOWSTARTED,Event::USER,Event::STRING_T);
	apush(Event::CONDORSHADOWSTARTED,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONDORSHADOWSTARTED,Event::JOBID,Event::JOBID_T);
	apush(Event::CONDORSHADOWSTARTED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONDORSHADOWSTARTED,Event::LEVEL,Event::INT_T);
	apush(Event::CONDORSHADOWSTARTED,Event::PRIORITY,Event::INT_T);
	apush(Event::CONDORSHADOWSTARTED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONDORSHADOWSTARTED,Event::HOST,Event::STRING_T);
	apush(Event::CONDORSHADOWSTARTED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORSHADOWSTARTED,Event::SHADOW_HOST,Event::STRING_T);
	apush(Event::CONDORSHADOWSTARTED,Event::SHADOW_STATUS,Event::STRING_T);
	apush(Event::CONDORSHADOWSTARTED,Event::SHADOW_PORT,Event::PORT_T);
	apush(Event::CONDORSHADOWSTARTED,Event::SHADOW_PID,Event::INT_T);
	apush(Event::FILETRANSFER,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::FILETRANSFER,Event::USER,Event::STRING_T);
	apush(Event::FILETRANSFER,Event::SEQCODE,Event::STRING_T);
	apush(Event::FILETRANSFER,Event::JOBID,Event::JOBID_T);
	apush(Event::FILETRANSFER,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::FILETRANSFER,Event::LEVEL,Event::INT_T);
	apush(Event::FILETRANSFER,Event::PRIORITY,Event::INT_T);
	apush(Event::FILETRANSFER,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::FILETRANSFER,Event::HOST,Event::STRING_T);
	apush(Event::FILETRANSFER,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::FILETRANSFER,Event::RESULT,Event::INT_T);
	apush(Event::FILETRANSFER,Event::REASON,Event::STRING_T);
	apush(Event::VMRUNNING,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::VMRUNNING,Event::USER,Event::STRING_T);
	apush(Event::VMRUNNING,Event::SEQCODE,Event::STRING_T);
	apush(Event::VMRUNNING,Event::JOBID,Event::JOBID_T);
	apush(Event::VMRUNNING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::VMRUNNING,Event::LEVEL,Event::INT_T);
	apush(Event::VMRUNNING,Event::PRIORITY,Event::INT_T);
	apush(Event::VMRUNNING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::VMRUNNING,Event::HOST,Event::STRING_T);
	apush(Event::VMRUNNING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::MATCH,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::MATCH,Event::USER,Event::STRING_T);
	apush(Event::MATCH,Event::SEQCODE,Event::STRING_T);
	apush(Event::MATCH,Event::JOBID,Event::JOBID_T);
	apush(Event::MATCH,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::MATCH,Event::LEVEL,Event::INT_T);
	apush(Event::MATCH,Event::PRIORITY,Event::INT_T);
	apush(Event::MATCH,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::MATCH,Event::HOST,Event::STRING_T);
	apush(Event::MATCH,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::MATCH,Event::DEST_ID,Event::STRING_T);
	apush(Event::REFUSED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::REFUSED,Event::USER,Event::STRING_T);
	apush(Event::REFUSED,Event::SEQCODE,Event::STRING_T);
	apush(Event::REFUSED,Event::JOBID,Event::JOBID_T);
	apush(Event::REFUSED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::REFUSED,Event::LEVEL,Event::INT_T);
	apush(Event::REFUSED,Event::PRIORITY,Event::INT_T);
	apush(Event::REFUSED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::REFUSED,Event::HOST,Event::STRING_T);
	apush(Event::REFUSED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::REFUSED,Event::FROM,Event::LOGSRC_T);
	apush(Event::REFUSED,Event::FROM_HOST,Event::STRING_T);
	apush(Event::REFUSED,Event::REASON,Event::STRING_T);
	apush(Event::REFUSED,Event::FROM_INSTANCE,Event::STRING_T);
	apush(Event::CREAMREALLYRUNNING,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMREALLYRUNNING,Event::USER,Event::STRING_T);
	apush(Event::CREAMREALLYRUNNING,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMREALLYRUNNING,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMREALLYRUNNING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMREALLYRUNNING,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMREALLYRUNNING,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMREALLYRUNNING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMREALLYRUNNING,Event::HOST,Event::STRING_T);
	apush(Event::CREAMREALLYRUNNING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORSTARTEREXITED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONDORSTARTEREXITED,Event::USER,Event::STRING_T);
	apush(Event::CONDORSTARTEREXITED,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONDORSTARTEREXITED,Event::JOBID,Event::JOBID_T);
	apush(Event::CONDORSTARTEREXITED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONDORSTARTEREXITED,Event::LEVEL,Event::INT_T);
	apush(Event::CONDORSTARTEREXITED,Event::PRIORITY,Event::INT_T);
	apush(Event::CONDORSTARTEREXITED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONDORSTARTEREXITED,Event::HOST,Event::STRING_T);
	apush(Event::CONDORSTARTEREXITED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORSTARTEREXITED,Event::STARTER_EXIT_STATUS,Event::INT_T);
	apush(Event::CONDORSTARTEREXITED,Event::JOB_PID,Event::INT_T);
	apush(Event::CONDORSTARTEREXITED,Event::JOB_EXIT_STATUS,Event::INT_T);
	apush(Event::CONDORSTARTEREXITED,Event::STARTER_PID,Event::INT_T);
	apush(Event::CREAMSTATUS,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMSTATUS,Event::USER,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMSTATUS,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMSTATUS,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMSTATUS,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMSTATUS,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::HOST,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMSTATUS,Event::FAILURE_REASON,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::WORKER_NODE,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::RESULT,Event::INT_T);
	apush(Event::CREAMSTATUS,Event::DESCR,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::NEW_STATE,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::OLD_STATE,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::LRMS_JOBID,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::EXIT_CODE,Event::STRING_T);
	apush(Event::CREAMSTATUS,Event::ORIG_TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORERROR,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONDORERROR,Event::USER,Event::STRING_T);
	apush(Event::CONDORERROR,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONDORERROR,Event::JOBID,Event::JOBID_T);
	apush(Event::CONDORERROR,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONDORERROR,Event::LEVEL,Event::INT_T);
	apush(Event::CONDORERROR,Event::PRIORITY,Event::INT_T);
	apush(Event::CONDORERROR,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONDORERROR,Event::HOST,Event::STRING_T);
	apush(Event::CONDORERROR,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORERROR,Event::ERROR_DESC,Event::STRING_T);
	apush(Event::LISTENER,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::LISTENER,Event::USER,Event::STRING_T);
	apush(Event::LISTENER,Event::SEQCODE,Event::STRING_T);
	apush(Event::LISTENER,Event::JOBID,Event::JOBID_T);
	apush(Event::LISTENER,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::LISTENER,Event::LEVEL,Event::INT_T);
	apush(Event::LISTENER,Event::PRIORITY,Event::INT_T);
	apush(Event::LISTENER,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::LISTENER,Event::HOST,Event::STRING_T);
	apush(Event::LISTENER,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::LISTENER,Event::SVC_NAME,Event::STRING_T);
	apush(Event::LISTENER,Event::SVC_HOST,Event::STRING_T);
	apush(Event::LISTENER,Event::SVC_PORT,Event::PORT_T);
	apush(Event::NOTIFICATION,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::NOTIFICATION,Event::USER,Event::STRING_T);
	apush(Event::NOTIFICATION,Event::SEQCODE,Event::STRING_T);
	apush(Event::NOTIFICATION,Event::JOBID,Event::JOBID_T);
	apush(Event::NOTIFICATION,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::NOTIFICATION,Event::LEVEL,Event::INT_T);
	apush(Event::NOTIFICATION,Event::PRIORITY,Event::INT_T);
	apush(Event::NOTIFICATION,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::NOTIFICATION,Event::HOST,Event::STRING_T);
	apush(Event::NOTIFICATION,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::NOTIFICATION,Event::EXPIRES,Event::INT_T);
	apush(Event::NOTIFICATION,Event::JOBSTAT,Event::STRING_T);
	apush(Event::NOTIFICATION,Event::OWNER,Event::STRING_T);
	apush(Event::NOTIFICATION,Event::NOTIFID,Event::NOTIFID_T);
	apush(Event::NOTIFICATION,Event::DEST_HOST,Event::STRING_T);
	apush(Event::NOTIFICATION,Event::DEST_URL,Event::STRING_T);
	apush(Event::NOTIFICATION,Event::DEST_PORT,Event::PORT_T);
	apush(Event::VMSHUTDOWN,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::VMSHUTDOWN,Event::USER,Event::STRING_T);
	apush(Event::VMSHUTDOWN,Event::SEQCODE,Event::STRING_T);
	apush(Event::VMSHUTDOWN,Event::JOBID,Event::JOBID_T);
	apush(Event::VMSHUTDOWN,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::VMSHUTDOWN,Event::LEVEL,Event::INT_T);
	apush(Event::VMSHUTDOWN,Event::PRIORITY,Event::INT_T);
	apush(Event::VMSHUTDOWN,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::VMSHUTDOWN,Event::HOST,Event::STRING_T);
	apush(Event::VMSHUTDOWN,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::VMSHUTDOWN,Event::USAGE,Event::STRING_T);
	apush(Event::PBSABORT,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSABORT,Event::USER,Event::STRING_T);
	apush(Event::PBSABORT,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSABORT,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSABORT,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSABORT,Event::LEVEL,Event::INT_T);
	apush(Event::PBSABORT,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSABORT,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSABORT,Event::HOST,Event::STRING_T);
	apush(Event::PBSABORT,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::ACCEPTED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::ACCEPTED,Event::USER,Event::STRING_T);
	apush(Event::ACCEPTED,Event::SEQCODE,Event::STRING_T);
	apush(Event::ACCEPTED,Event::JOBID,Event::JOBID_T);
	apush(Event::ACCEPTED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::ACCEPTED,Event::LEVEL,Event::INT_T);
	apush(Event::ACCEPTED,Event::PRIORITY,Event::INT_T);
	apush(Event::ACCEPTED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::ACCEPTED,Event::HOST,Event::STRING_T);
	apush(Event::ACCEPTED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::ACCEPTED,Event::FROM_INSTANCE,Event::STRING_T);
	apush(Event::ACCEPTED,Event::LOCAL_JOBID,Event::STRING_T);
	apush(Event::ACCEPTED,Event::FROM_HOST,Event::STRING_T);
	apush(Event::ACCEPTED,Event::FROM,Event::LOGSRC_T);
	apush(Event::VMSTOP,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::VMSTOP,Event::USER,Event::STRING_T);
	apush(Event::VMSTOP,Event::SEQCODE,Event::STRING_T);
	apush(Event::VMSTOP,Event::JOBID,Event::JOBID_T);
	apush(Event::VMSTOP,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::VMSTOP,Event::LEVEL,Event::INT_T);
	apush(Event::VMSTOP,Event::PRIORITY,Event::INT_T);
	apush(Event::VMSTOP,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::VMSTOP,Event::HOST,Event::STRING_T);
	apush(Event::VMSTOP,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::RESOURCEUSAGE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::RESOURCEUSAGE,Event::USER,Event::STRING_T);
	apush(Event::RESOURCEUSAGE,Event::SEQCODE,Event::STRING_T);
	apush(Event::RESOURCEUSAGE,Event::JOBID,Event::JOBID_T);
	apush(Event::RESOURCEUSAGE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::RESOURCEUSAGE,Event::LEVEL,Event::INT_T);
	apush(Event::RESOURCEUSAGE,Event::PRIORITY,Event::INT_T);
	apush(Event::RESOURCEUSAGE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::RESOURCEUSAGE,Event::HOST,Event::STRING_T);
	apush(Event::RESOURCEUSAGE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::RESOURCEUSAGE,Event::QUANTITY,Event::DOUBLE_T);
	apush(Event::RESOURCEUSAGE,Event::UNIT,Event::STRING_T);
	apush(Event::RESOURCEUSAGE,Event::RESOURCE,Event::STRING_T);
	apush(Event::CANCEL,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CANCEL,Event::USER,Event::STRING_T);
	apush(Event::CANCEL,Event::SEQCODE,Event::STRING_T);
	apush(Event::CANCEL,Event::JOBID,Event::JOBID_T);
	apush(Event::CANCEL,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CANCEL,Event::LEVEL,Event::INT_T);
	apush(Event::CANCEL,Event::PRIORITY,Event::INT_T);
	apush(Event::CANCEL,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CANCEL,Event::HOST,Event::STRING_T);
	apush(Event::CANCEL,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CANCEL,Event::REASON,Event::STRING_T);
	apush(Event::CANCEL,Event::STATUS_CODE,Event::INT_T);
	apush(Event::PBSTRANSFER,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSTRANSFER,Event::USER,Event::STRING_T);
	apush(Event::PBSTRANSFER,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSTRANSFER,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSTRANSFER,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSTRANSFER,Event::LEVEL,Event::INT_T);
	apush(Event::PBSTRANSFER,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSTRANSFER,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSTRANSFER,Event::HOST,Event::STRING_T);
	apush(Event::PBSTRANSFER,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSTRANSFER,Event::DESTINATION,Event::LOGSRC_T);
	apush(Event::PBSTRANSFER,Event::DEST_INSTANCE,Event::STRING_T);
	apush(Event::PBSTRANSFER,Event::DEST_JOBID,Event::STRING_T);
	apush(Event::PBSTRANSFER,Event::RESULT,Event::INT_T);
	apush(Event::PBSTRANSFER,Event::REASON,Event::STRING_T);
	apush(Event::CREAMCALL,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMCALL,Event::USER,Event::STRING_T);
	apush(Event::CREAMCALL,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMCALL,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMCALL,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMCALL,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMCALL,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMCALL,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMCALL,Event::HOST,Event::STRING_T);
	apush(Event::CREAMCALL,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMCALL,Event::RESULT,Event::INT_T);
	apush(Event::CREAMCALL,Event::COMMAND,Event::INT_T);
	apush(Event::CREAMCALL,Event::REASON,Event::STRING_T);
	apush(Event::CREAMCALL,Event::CALLEE,Event::LOGSRC_T);
	apush(Event::CREAMCALL,Event::DESTID,Event::STRING_T);
	apush(Event::CREAMCALL,Event::CMDID,Event::STRING_T);
	apush(Event::VMRESUME,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::VMRESUME,Event::USER,Event::STRING_T);
	apush(Event::VMRESUME,Event::SEQCODE,Event::STRING_T);
	apush(Event::VMRESUME,Event::JOBID,Event::JOBID_T);
	apush(Event::VMRESUME,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::VMRESUME,Event::LEVEL,Event::INT_T);
	apush(Event::VMRESUME,Event::PRIORITY,Event::INT_T);
	apush(Event::VMRESUME,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::VMRESUME,Event::HOST,Event::STRING_T);
	apush(Event::VMRESUME,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::HELPERCALL,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::HELPERCALL,Event::USER,Event::STRING_T);
	apush(Event::HELPERCALL,Event::SEQCODE,Event::STRING_T);
	apush(Event::HELPERCALL,Event::JOBID,Event::JOBID_T);
	apush(Event::HELPERCALL,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::HELPERCALL,Event::LEVEL,Event::INT_T);
	apush(Event::HELPERCALL,Event::PRIORITY,Event::INT_T);
	apush(Event::HELPERCALL,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::HELPERCALL,Event::HOST,Event::STRING_T);
	apush(Event::HELPERCALL,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::HELPERCALL,Event::HELPER_NAME,Event::STRING_T);
	apush(Event::HELPERCALL,Event::SRC_ROLE,Event::INT_T);
	apush(Event::HELPERCALL,Event::HELPER_PARAMS,Event::STRING_T);
	apush(Event::PBSERROR,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSERROR,Event::USER,Event::STRING_T);
	apush(Event::PBSERROR,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSERROR,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSERROR,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSERROR,Event::LEVEL,Event::INT_T);
	apush(Event::PBSERROR,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSERROR,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSERROR,Event::HOST,Event::STRING_T);
	apush(Event::PBSERROR,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSERROR,Event::ERROR_DESC,Event::STRING_T);
	apush(Event::COLLECTIONSTATE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::COLLECTIONSTATE,Event::USER,Event::STRING_T);
	apush(Event::COLLECTIONSTATE,Event::SEQCODE,Event::STRING_T);
	apush(Event::COLLECTIONSTATE,Event::JOBID,Event::JOBID_T);
	apush(Event::COLLECTIONSTATE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::COLLECTIONSTATE,Event::LEVEL,Event::INT_T);
	apush(Event::COLLECTIONSTATE,Event::PRIORITY,Event::INT_T);
	apush(Event::COLLECTIONSTATE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::COLLECTIONSTATE,Event::HOST,Event::STRING_T);
	apush(Event::COLLECTIONSTATE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::COLLECTIONSTATE,Event::DONE_CODE,Event::INT_T);
	apush(Event::COLLECTIONSTATE,Event::CHILD,Event::JOBID_T);
	apush(Event::COLLECTIONSTATE,Event::CHILD_EVENT,Event::STRING_T);
	apush(Event::COLLECTIONSTATE,Event::HISTOGRAM,Event::STRING_T);
	apush(Event::COLLECTIONSTATE,Event::STATE,Event::STRING_T);
	apush(Event::ABORT,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::ABORT,Event::USER,Event::STRING_T);
	apush(Event::ABORT,Event::SEQCODE,Event::STRING_T);
	apush(Event::ABORT,Event::JOBID,Event::JOBID_T);
	apush(Event::ABORT,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::ABORT,Event::LEVEL,Event::INT_T);
	apush(Event::ABORT,Event::PRIORITY,Event::INT_T);
	apush(Event::ABORT,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::ABORT,Event::HOST,Event::STRING_T);
	apush(Event::ABORT,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::ABORT,Event::REASON,Event::STRING_T);
	apush(Event::ENQUEUED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::ENQUEUED,Event::USER,Event::STRING_T);
	apush(Event::ENQUEUED,Event::SEQCODE,Event::STRING_T);
	apush(Event::ENQUEUED,Event::JOBID,Event::JOBID_T);
	apush(Event::ENQUEUED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::ENQUEUED,Event::LEVEL,Event::INT_T);
	apush(Event::ENQUEUED,Event::PRIORITY,Event::INT_T);
	apush(Event::ENQUEUED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::ENQUEUED,Event::HOST,Event::STRING_T);
	apush(Event::ENQUEUED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::ENQUEUED,Event::REASON,Event::STRING_T);
	apush(Event::ENQUEUED,Event::QUEUE,Event::STRING_T);
	apush(Event::ENQUEUED,Event::JOB,Event::STRING_T);
	apush(Event::ENQUEUED,Event::RESULT,Event::INT_T);
	apush(Event::USERTAG,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::USERTAG,Event::USER,Event::STRING_T);
	apush(Event::USERTAG,Event::SEQCODE,Event::STRING_T);
	apush(Event::USERTAG,Event::JOBID,Event::JOBID_T);
	apush(Event::USERTAG,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::USERTAG,Event::LEVEL,Event::INT_T);
	apush(Event::USERTAG,Event::PRIORITY,Event::INT_T);
	apush(Event::USERTAG,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::USERTAG,Event::HOST,Event::STRING_T);
	apush(Event::USERTAG,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::USERTAG,Event::VALUE,Event::STRING_T);
	apush(Event::USERTAG,Event::NAME,Event::STRING_T);
	apush(Event::REALLYRUNNING,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::REALLYRUNNING,Event::USER,Event::STRING_T);
	apush(Event::REALLYRUNNING,Event::SEQCODE,Event::STRING_T);
	apush(Event::REALLYRUNNING,Event::JOBID,Event::JOBID_T);
	apush(Event::REALLYRUNNING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::REALLYRUNNING,Event::LEVEL,Event::INT_T);
	apush(Event::REALLYRUNNING,Event::PRIORITY,Event::INT_T);
	apush(Event::REALLYRUNNING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::REALLYRUNNING,Event::HOST,Event::STRING_T);
	apush(Event::REALLYRUNNING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::REALLYRUNNING,Event::WN_SEQ,Event::STRING_T);
	apush(Event::VMHOST,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::VMHOST,Event::USER,Event::STRING_T);
	apush(Event::VMHOST,Event::SEQCODE,Event::STRING_T);
	apush(Event::VMHOST,Event::JOBID,Event::JOBID_T);
	apush(Event::VMHOST,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::VMHOST,Event::LEVEL,Event::INT_T);
	apush(Event::VMHOST,Event::PRIORITY,Event::INT_T);
	apush(Event::VMHOST,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::VMHOST,Event::HOST,Event::STRING_T);
	apush(Event::VMHOST,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::VMHOST,Event::HOSTNAME,Event::STRING_T);
	apush(Event::VMIMAGE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::VMIMAGE,Event::USER,Event::STRING_T);
	apush(Event::VMIMAGE,Event::SEQCODE,Event::STRING_T);
	apush(Event::VMIMAGE,Event::JOBID,Event::JOBID_T);
	apush(Event::VMIMAGE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::VMIMAGE,Event::LEVEL,Event::INT_T);
	apush(Event::VMIMAGE,Event::PRIORITY,Event::INT_T);
	apush(Event::VMIMAGE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::VMIMAGE,Event::HOST,Event::STRING_T);
	apush(Event::VMIMAGE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::VMIMAGE,Event::IMAGE,Event::STRING_T);
	apush(Event::CREAMSTORE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMSTORE,Event::USER,Event::STRING_T);
	apush(Event::CREAMSTORE,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMSTORE,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMSTORE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMSTORE,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMSTORE,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMSTORE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMSTORE,Event::HOST,Event::STRING_T);
	apush(Event::CREAMSTORE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMSTORE,Event::CMDID,Event::STRING_T);
	apush(Event::CREAMSTORE,Event::REASON,Event::STRING_T);
	apush(Event::CREAMSTORE,Event::COMMAND,Event::INT_T);
	apush(Event::CREAMSTORE,Event::RESULT,Event::INT_T);
	apush(Event::CHKPT,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CHKPT,Event::USER,Event::STRING_T);
	apush(Event::CHKPT,Event::SEQCODE,Event::STRING_T);
	apush(Event::CHKPT,Event::JOBID,Event::JOBID_T);
	apush(Event::CHKPT,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CHKPT,Event::LEVEL,Event::INT_T);
	apush(Event::CHKPT,Event::PRIORITY,Event::INT_T);
	apush(Event::CHKPT,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CHKPT,Event::HOST,Event::STRING_T);
	apush(Event::CHKPT,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CHKPT,Event::TAG,Event::STRING_T);
	apush(Event::CHKPT,Event::CLASSAD,Event::STRING_T);
	apush(Event::CREAMPURGE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMPURGE,Event::USER,Event::STRING_T);
	apush(Event::CREAMPURGE,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMPURGE,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMPURGE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMPURGE,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMPURGE,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMPURGE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMPURGE,Event::HOST,Event::STRING_T);
	apush(Event::CREAMPURGE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSMATCH,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSMATCH,Event::USER,Event::STRING_T);
	apush(Event::PBSMATCH,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSMATCH,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSMATCH,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSMATCH,Event::LEVEL,Event::INT_T);
	apush(Event::PBSMATCH,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSMATCH,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSMATCH,Event::HOST,Event::STRING_T);
	apush(Event::PBSMATCH,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSMATCH,Event::DEST_HOST,Event::STRING_T);
	apush(Event::DEQUEUED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::DEQUEUED,Event::USER,Event::STRING_T);
	apush(Event::DEQUEUED,Event::SEQCODE,Event::STRING_T);
	apush(Event::DEQUEUED,Event::JOBID,Event::JOBID_T);
	apush(Event::DEQUEUED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::DEQUEUED,Event::LEVEL,Event::INT_T);
	apush(Event::DEQUEUED,Event::PRIORITY,Event::INT_T);
	apush(Event::DEQUEUED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::DEQUEUED,Event::HOST,Event::STRING_T);
	apush(Event::DEQUEUED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::DEQUEUED,Event::LOCAL_JOBID,Event::STRING_T);
	apush(Event::DEQUEUED,Event::QUEUE,Event::STRING_T);
	apush(Event::CREAMABORT,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMABORT,Event::USER,Event::STRING_T);
	apush(Event::CREAMABORT,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMABORT,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMABORT,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMABORT,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMABORT,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMABORT,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMABORT,Event::HOST,Event::STRING_T);
	apush(Event::CREAMABORT,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMABORT,Event::REASON,Event::STRING_T);
	apush(Event::PBSDEQUEUED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSDEQUEUED,Event::USER,Event::STRING_T);
	apush(Event::PBSDEQUEUED,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSDEQUEUED,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSDEQUEUED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSDEQUEUED,Event::LEVEL,Event::INT_T);
	apush(Event::PBSDEQUEUED,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSDEQUEUED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSDEQUEUED,Event::HOST,Event::STRING_T);
	apush(Event::PBSDEQUEUED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::FILETRANSFERREGISTER,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::FILETRANSFERREGISTER,Event::USER,Event::STRING_T);
	apush(Event::FILETRANSFERREGISTER,Event::SEQCODE,Event::STRING_T);
	apush(Event::FILETRANSFERREGISTER,Event::JOBID,Event::JOBID_T);
	apush(Event::FILETRANSFERREGISTER,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::FILETRANSFERREGISTER,Event::LEVEL,Event::INT_T);
	apush(Event::FILETRANSFERREGISTER,Event::PRIORITY,Event::INT_T);
	apush(Event::FILETRANSFERREGISTER,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::FILETRANSFERREGISTER,Event::HOST,Event::STRING_T);
	apush(Event::FILETRANSFERREGISTER,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::FILETRANSFERREGISTER,Event::SRC,Event::STRING_T);
	apush(Event::FILETRANSFERREGISTER,Event::DEST,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::RESUBMISSION,Event::USER,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::SEQCODE,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::JOBID,Event::JOBID_T);
	apush(Event::RESUBMISSION,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::RESUBMISSION,Event::LEVEL,Event::INT_T);
	apush(Event::RESUBMISSION,Event::PRIORITY,Event::INT_T);
	apush(Event::RESUBMISSION,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::HOST,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::RESUBMISSION,Event::REASON,Event::STRING_T);
	apush(Event::RESUBMISSION,Event::RESULT,Event::INT_T);
	apush(Event::RESUBMISSION,Event::TAG,Event::STRING_T);
	apush(Event::CREAMCANCEL,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CREAMCANCEL,Event::USER,Event::STRING_T);
	apush(Event::CREAMCANCEL,Event::SEQCODE,Event::STRING_T);
	apush(Event::CREAMCANCEL,Event::JOBID,Event::JOBID_T);
	apush(Event::CREAMCANCEL,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CREAMCANCEL,Event::LEVEL,Event::INT_T);
	apush(Event::CREAMCANCEL,Event::PRIORITY,Event::INT_T);
	apush(Event::CREAMCANCEL,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CREAMCANCEL,Event::HOST,Event::STRING_T);
	apush(Event::CREAMCANCEL,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CREAMCANCEL,Event::REASON,Event::STRING_T);
	apush(Event::CREAMCANCEL,Event::STATUS_CODE,Event::INT_T);
	apush(Event::PBSREFUSED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSREFUSED,Event::USER,Event::STRING_T);
	apush(Event::PBSREFUSED,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSREFUSED,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSREFUSED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSREFUSED,Event::LEVEL,Event::INT_T);
	apush(Event::PBSREFUSED,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSREFUSED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSREFUSED,Event::HOST,Event::STRING_T);
	apush(Event::PBSREFUSED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSREFUSED,Event::FROM,Event::LOGSRC_T);
	apush(Event::PBSREFUSED,Event::REASON,Event::STRING_T);
	apush(Event::PBSREFUSED,Event::FROM_INSTANCE,Event::STRING_T);
	apush(Event::VMDONE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::VMDONE,Event::USER,Event::STRING_T);
	apush(Event::VMDONE,Event::SEQCODE,Event::STRING_T);
	apush(Event::VMDONE,Event::JOBID,Event::JOBID_T);
	apush(Event::VMDONE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::VMDONE,Event::LEVEL,Event::INT_T);
	apush(Event::VMDONE,Event::PRIORITY,Event::INT_T);
	apush(Event::VMDONE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::VMDONE,Event::HOST,Event::STRING_T);
	apush(Event::VMDONE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::VMDONE,Event::STATUS_CODE,Event::INT_T);
	apush(Event::VMDONE,Event::USAGE,Event::STRING_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::USER,Event::STRING_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::SEQCODE,Event::STRING_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::JOBID,Event::JOBID_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::LEVEL,Event::INT_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::PRIORITY,Event::INT_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::HOST,Event::STRING_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::USAGE,Event::INT_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::NAME,Event::STRING_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::UNIT,Event::STRING_T);
	apush(Event::CONDORRESOURCEUSAGE,Event::QUANTITY,Event::DOUBLE_T);
	apush(Event::PENDING,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PENDING,Event::USER,Event::STRING_T);
	apush(Event::PENDING,Event::SEQCODE,Event::STRING_T);
	apush(Event::PENDING,Event::JOBID,Event::JOBID_T);
	apush(Event::PENDING,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PENDING,Event::LEVEL,Event::INT_T);
	apush(Event::PENDING,Event::PRIORITY,Event::INT_T);
	apush(Event::PENDING,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PENDING,Event::HOST,Event::STRING_T);
	apush(Event::PENDING,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PENDING,Event::REASON,Event::STRING_T);
	apush(Event::REGJOB,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::REGJOB,Event::USER,Event::STRING_T);
	apush(Event::REGJOB,Event::SEQCODE,Event::STRING_T);
	apush(Event::REGJOB,Event::JOBID,Event::JOBID_T);
	apush(Event::REGJOB,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::REGJOB,Event::LEVEL,Event::INT_T);
	apush(Event::REGJOB,Event::PRIORITY,Event::INT_T);
	apush(Event::REGJOB,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::REGJOB,Event::HOST,Event::STRING_T);
	apush(Event::REGJOB,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::REGJOB,Event::JOBTYPE,Event::INT_T);
	apush(Event::REGJOB,Event::NS,Event::STRING_T);
	apush(Event::REGJOB,Event::NSUBJOBS,Event::INT_T);
	apush(Event::REGJOB,Event::PARENT,Event::JOBID_T);
	apush(Event::REGJOB,Event::JDL,Event::STRING_T);
	apush(Event::REGJOB,Event::SEED,Event::STRING_T);
	apush(Event::REGJOB,Event::WMS_DN,Event::STRING_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::USER,Event::STRING_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::LEVEL,Event::INT_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::HOST,Event::STRING_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::NEWSTATE,Event::INT_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::OLDSUBSTATE,Event::INT_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::OLDSTATE,Event::INT_T);
	apush(Event::PBSINTERNALSTATECHANGE,Event::NEWSUBSTATE,Event::INT_T);
	apush(Event::DISCONNECTJOB,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::DISCONNECTJOB,Event::USER,Event::STRING_T);
	apush(Event::DISCONNECTJOB,Event::SEQCODE,Event::STRING_T);
	apush(Event::DISCONNECTJOB,Event::JOBID,Event::JOBID_T);
	apush(Event::DISCONNECTJOB,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::DISCONNECTJOB,Event::LEVEL,Event::INT_T);
	apush(Event::DISCONNECTJOB,Event::PRIORITY,Event::INT_T);
	apush(Event::DISCONNECTJOB,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::DISCONNECTJOB,Event::HOST,Event::STRING_T);
	apush(Event::DISCONNECTJOB,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::DISCONNECTJOB,Event::DEST_JOBID,Event::STRING_T);
	apush(Event::RESUME,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::RESUME,Event::USER,Event::STRING_T);
	apush(Event::RESUME,Event::SEQCODE,Event::STRING_T);
	apush(Event::RESUME,Event::JOBID,Event::JOBID_T);
	apush(Event::RESUME,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::RESUME,Event::LEVEL,Event::INT_T);
	apush(Event::RESUME,Event::PRIORITY,Event::INT_T);
	apush(Event::RESUME,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::RESUME,Event::HOST,Event::STRING_T);
	apush(Event::RESUME,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::RESUME,Event::REASON,Event::STRING_T);
	apush(Event::PBSQUEUED,Event::ARRIVED,Event::TIMEVAL_T);
	apush(Event::PBSQUEUED,Event::USER,Event::STRING_T);
	apush(Event::PBSQUEUED,Event::SEQCODE,Event::STRING_T);
	apush(Event::PBSQUEUED,Event::JOBID,Event::JOBID_T);
	apush(Event::PBSQUEUED,Event::SOURCE,Event::LOGSRC_T);
	apush(Event::PBSQUEUED,Event::LEVEL,Event::INT_T);
	apush(Event::PBSQUEUED,Event::PRIORITY,Event::INT_T);
	apush(Event::PBSQUEUED,Event::SRC_INSTANCE,Event::STRING_T);
	apush(Event::PBSQUEUED,Event::HOST,Event::STRING_T);
	apush(Event::PBSQUEUED,Event::TIMESTAMP,Event::TIMEVAL_T);
	apush(Event::PBSQUEUED,Event::QUEUE,Event::STRING_T);
	apush(Event::PBSQUEUED,Event::OWNER,Event::STRING_T);
	apush(Event::PBSQUEUED,Event::NAME,Event::STRING_T);
}

std::vector<std::pair<Event::Attr,Event::AttrType> > const & Event::getAttrs(void) const
{
  if (type<0 || type>=TYPE_MAX) {
    STACK_ADD;
    throw(Exception(EXCEPTION_MANDATORY, EINVAL, "invalid event type"));
  }
  
  /* FIXME: thread safety */
  if (!attrs_inited) {
    init_attrs();
    attrs_inited = true;
  }
  
  return attrs[type];
}


const std::string Event::getEventName(Type type)
{
	char *s;

	if(type < 0 || type >= TYPE_MAX) {
		STACK_ADD;
		throw(Exception(EXCEPTION_MANDATORY, EINVAL, "invalid event type"));
	}

	s = edg_wll_EventToString(edg_wll_EventCode(type));
	if (!s) {
		STACK_ADD;
		throw(Exception(EXCEPTION_MANDATORY, EINVAL, "invalid event type"));
	}
	std::string ret(s);
	free(s);
	return ret;
}


void 
Event::destroyFlesh(void *in) 
{
  edg_wll_FreeEvent((edg_wll_Event *) in);
  free(in);
}

EWL_END_NAMESPACE;
